//---------------------------------------------------------------------------
#ifndef TGameFormH
#define TGameFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include "TDPChat.h"
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
// these are the different message types
#define GAME_TICK_MESSAGE		0
#define	PLAYER_CLICK_MESSAGE	1
#define PLAYER_TEXT_MESSAGE		2
//---------------------------------------------------------------------------
#define MESSAGESTRUCT_HEADER_LENGTH		5		// bytes
//---------------------------------------------------------------------------
typedef struct {
	byte Message_Type;
    dword Message_Length;
    char Message_Data;
    } MessageStruct;
//---------------------------------------------------------------------------
typedef struct {
    int x,y;
    TColor color;
    dword score;
    bool Is_Hit;
    bool Is_Flashing;
    bool Is_Running;
    int Interval;
    } GameInfoStruct;
//---------------------------------------------------------------------------

#if (__BORLANDC__ < 0x0530) // BCB Version 1
class TGameForm : public TForm
{
#else // BCB Version 3+
class PACKAGE TGameForm : public TForm
{
#endif

__published:	// IDE-managed Components
	TDPChat *DPChat1;
	TGroupBox *GroupBox2;
	TGroupBox *GroupBox3;
	TEdit *Edit2;
	TButton *Button3;
	TButton *Button5;
	TListBox *MessageListBox;
	TLabel *Label3;
	TButton *Button4;
	TGroupBox *GroupBox1;
	TLabel *Label1;
	TImage *Image1;
	TTimer *Timer1;
	TLabel *ScoreLabel;
	TLabel *HiScoreLabel;
	TLabel *Label4;
	void __fastcall Button3Click(TObject *Sender);
	void __fastcall Button4Click(TObject *Sender);
	void __fastcall Button5Click(TObject *Sender);
	
	
	void __fastcall FormShow(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	
	void __fastcall Image1MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall FormHide(TObject *Sender);
	
private:	// User declarations
public:		// User declarations

	MessageStruct* Message;
    void __fastcall PaintDot( int x, int y, TColor color );
    GameInfoStruct GameInfo;

	__fastcall TGameForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
#if (__BORLANDC__ < 0x0530) // BCB Version 1
extern TGameForm *GameForm;
#else // BCB Version 3+
extern PACKAGE TGameForm *GameForm;
#endif
//---------------------------------------------------------------------------
#endif
